from types import *
import new, string

CO_OPTIMIZED	= 0x0001
CO_NEWLOCALS	= 0x0002
CO_VARARGS	= 0x0004
CO_VARKEYWORDS  = 0x0008


#
# This is a real gem ;)
#

# ct981218 patch for Python 1.5.2a2
# added stacksize default

def patch_consts(func, name=None, globals=None, locals={}, stacksize=1):
    if name is None:
        name = func.func_name
    if globals is None:
        globals = func.func_globals
    code = func.func_code
    constants = list(code.co_consts)
    for i in range(len(constants)):
        c = constants[i]
        if type(c) is StringType and len(c) > 4:
            if c[:2] == '__' and c[-2:] == '__':
                constants[i] = eval(c[2:-2], globals, locals)
    constants = tuple(constants)
    
#   code = new.code(code.co_argcount, code.co_nlocals, code.co_flags,
#                   code.co_code, constants, code.co_names,
#                   code.co_varnames, code.co_filename, code.co_name)
# 1.5:
# Create a code object from (ARGCOUNT, NLOCALS, STACKSIZE, FLAGS, CODESTRING, CONSTANTS, NAMES, VARNAMES, FILENAME, NAME, FIRSTLINENO, LNOTAB).

    code = new.code(code.co_argcount, code.co_nlocals, stacksize, code.co_flags,
                    code.co_code, constants, code.co_names,
                    code.co_varnames, code.co_filename, code.co_name,
                    0, "")

    return new.function(code, func.func_globals, name)
    


#    
# dictionary and appending them to the tuple.
# This is what happens when a function is called, the hope
# is that we can do it once now, rather than many times later.
#
def process_keywords(func, args, kws):
# ct981218 use copy now:
#   kws = apply(lambda **x:x, (), kws)
    kws = kws.copy()
    code = func.func_code
    names = code.co_names
    got = names[:len(args)]
    for name, i in map(None, got, range(len(got))):
        if kws.has_key(name):
            raise TypeError, 'keyword parameter redefined [%s]' % name
        kws[name] = args[i]
    extra_args = args[len(got):]
    args = []
    for name in names:
        if not kws.has_key(name):
# ct981218 corrected:
            # break
            continue
        args.append(kws[name])
        del kws[name]
    args = tuple(args) + tuple(extra_args)
    if len(args) > code.co_argcount and not (code.co_flags & CO_VARARGS):
        raise TypeError, "too many arguments"
    if kws and not (code.co_flags & CO_VARKEYWORDS):
        raise TypeError, "extra keywords [%s]" % string.join(kws.keys(), ",")
    return args, kws
